% Demo of applying TDL on PRID and ILIDS-VID
% Last updated: 2016/7/6
clear ; close ;clc ;

%% dataset name
dataset_name='prid';% 'prid' or 'ilids'

%% parameters
pars.outdim = 120; % output dimension of TDL
pars.alpha = 0.2; % weight of push term in objective function
pars.maxiter = 1000; % max iteration count

%% 
addpath(genpath('./data'));
switch dataset_name
    case 'prid'
        load('cv_split_prid.mat')
        load('normed_hog3dColourLBP_cam_a.mat');
        cam1_feature=double(X');
        load('normed_hog3dColourLBP_cam_b.mat');
        cam2_feature=double(X');
        cam1_count=ones(1,178);
        cam2_count=ones(1,178);
        pars.dem_pca = 177; % number of samples minus 1
    case 'ilids'
        load('cv_split_ilidsvid.mat')
        load('normed_hog3dColourLBP_cam1.mat');
        cam1_feature=double(X');
        load('normed_hog3dColourLBP_cam2.mat');
        cam2_feature=double(X');
        cam1_count=ones(1,300);
        cam2_count=ones(1,300);
        pars.dem_pca = 299; % number of samples minus 1
end
disp(['Evaluation on ' dataset_name '.']);
%matrix transforms to cells for each person
cam1_feat=feature_mat2cell(cam1_feature,cam1_count);
cam2_feat=feature_mat2cell(cam2_feature,cam2_count);

for s = 1:10

disp(['Experiment No.',num2str(s)])   
target = ls_set(s,:); %%training/testing seting

%% dataset is split into two subsets of equal size
[TrainingTargetDataSetC,GalleryDataSetC,TestingTargetDataSetC,CountOfTrainingTargetSamples,CountOfGalleryTargetSamples,CountOfTestingTargetSamples]...
         = spilt_dataset(cam1_feat,cam2_feat,target);

% learn the metric by TDL
[L, pca_para] = TDL_train(TrainingTargetDataSetC, CountOfTrainingTargetSamples, pars);
% M=L'*L;

%% testing
% - get the distance matrix
 [ DistanceMatrix ] = get_DistanceMatrix(GalleryDataSetC,TestingTargetDataSetC,CountOfGalleryTargetSamples,CountOfTestingTargetSamples,L,pca_para);
% % the DistanceMatrix(i,j) is the distance value
% % between the ith gallery sample and jth testing sample

% - get the n rank recognition rate
[ RateMat ] = computeRankRate(DistanceMatrix,CountOfTestingTargetSamples,pars);
% % the RateMat(i,j) is the distance value
%%=========================================================================
RankRateMat(s,:)=RateMat;
end

%-show
disp('Average accuracy of rank 1 5 10 15 20');
FinalRankRate=mean(RankRateMat,1); %average rank rate of 10 experiments
disp(FinalRankRate([1 5 10 15 20]));
plot(FinalRankRate,'b-v');
