function [ RateMat ] = computeRankRate(DistMat,ct,pars )
% compute rank rate from distance matrix
% ct=CountOfTestingTargetSamples
% the DistanceMatrix(i,j) is the distance value
% between the ith gallery sample and jth testing sample
[~,Index] = sort(DistMat);

TestSampleAmount=length(ct);
ArrayWithClassLabel = 1:TestSampleAmount;
for rank = 1 : TestSampleAmount
    Temp = Index(1 : rank,:) == ones(rank,1) * ArrayWithClassLabel;    
    Rank1cAccRate = sum(sum(Temp==1,1)) / TestSampleAmount;
    RateMat(1,rank) = Rank1cAccRate*100;
end
disp('Accuracy of rank 1 5 10 15 20');
disp(RateMat([1 5 10 15 20]));
end

