function [ DistMat ] = get_DistanceMatrix(xg,xt,cg,ct,L,pars)
%
% cg=CountOfGalleryTargetSamples,
% ct=CountOfTestingTargetSamples
% the DistanceMatrix(i,j) is the distance value
% between the ith gallery sample and jth testing sample

% - get the distance matrix
    xg = xg'*pars.projection;
    xg = xg(:,1:pars.dim)';
    xt = xt'*pars.projection;
    xt = xt(:,1:pars.dim)';
DistMat = zeros(sum(cg),sum(ct));
for i = 1 : sum(ct)
    % learn the difference vector
    DiffSetC = abs(L*xg-L*xt(:,i)*ones(1,sum(cg)));
    DistMat(:,i) = sum(DiffSetC.^2,1);   
end
                    
end

