function [xtr,xg,xt,ctr,cg,ct]= spilt_dataset(cam1_feat,cam2_feat,target)
% output:
% xtr-feature columns of Training Set,
% xg--feature columns of Gallery Set,
% xt--feature columns of Testing Set,
% ctr--Count Of Training Target Samples
% cg--Count Of Gallery Target Samples
% ct--Count Of Testing Target Samples
%input:
%cam1_feat,cam2_feat: features of each person in cell 
%target : label of each person 

%%  spilt dataset
%-setting
threshold = 10;%maxinum of sample for each person in each set
shot_flag=1;%set 1 for single-shot,0 for multi-shot
%NumOfTraining=100;%you can set it
NumOfPerson=size(target,2);
NumOfTraining=fix(NumOfPerson/2);%%%dataset is split into two subsets of equal size
NumOfGallery= NumOfPerson - NumOfTraining;%%the same as number of testing
%get Tergets for each set
% SortedTrainingTarget =sort(target(1:NumOfTraining));%target
TrainingTarget = target(1:NumOfTraining);%target
% RemainTarget=target;
% RemainTarget(1:NumOfTraining)=[];%
%% get sets
xtr=[];
xg=[];
xt=[];
ctr=[];
cg=[];
ct=[];
% get trainingset
 for i=1:NumOfTraining
 current_Training_featC=[cam1_feat{TrainingTarget(i)} cam2_feat{TrainingTarget(i)}];
 current_Training_count=size(current_Training_featC,2);
     if   current_Training_count > threshold
        target_temp = randperm(current_Training_count);
        xtr =[xtr current_Training_featC(:,target_temp(1:threshold))]; 
        ctr =[ctr threshold];
     else
        xtr =[xtr current_Training_featC];
        ctr =[ ctr current_Training_count];
     end
 end
 % get galleryset----single-shot/multi-shot
 for i=1:NumOfGallery
 cam1RemainDataSetC=cam1_feat;
 cam1RemainDataSetC(:,TrainingTarget)=[];
 current_Gallery_featC=cam1RemainDataSetC{i};
 current_Gallery_count=size(current_Gallery_featC,2);
 target_temp = randperm(current_Gallery_count);
     if shot_flag  %chose single-shot
         xg= [xg current_Gallery_featC(:, target_temp(1))];
         cg = ones(1,NumOfGallery);
     else  %chose multi-shot
        if   current_Gallery_count > threshold  
            target_temp = randperm(current_Gallery_count);
            xg=[xg current_Gallery_featC(:,target_temp(1:threshold))]; 
            cg =[cg threshold];
        else
            xg =[xg current_Gallery_featC];
            cg =[ cg current_Gallery_count];
        end
     end
 end
 % get testingset
 for i=1:NumOfGallery
 cam2RemainDataSetC=cam2_feat;
 cam2RemainDataSetC(:,TrainingTarget)=[];
 current_Testing_featC=cam2RemainDataSetC{i};
 current_Testing_count=size(current_Testing_featC,2);
     if   current_Testing_count > threshold
        target_temp = randperm(current_Testing_count);
         xt =[ xt current_Testing_featC(:,target_temp(1:threshold))]; 
        ct =[ct threshold];
     else
         xt =[ xt current_Testing_featC];
        ct =[ ct current_Testing_count];
     end
 end

end

